# Rappid

The HTML5 diagramming toolkit. Extends [JointJS](https://github.com/clientIO/joint) with plugins for UI, shapes, data storage, real-time collaboration, layout algorithms, and more.

See [http://jointjs.com/rappid/docs](http://jointjs.com/docs/rappid) for the complete list of modules and documentation.


## Quick Start

Probably the best way to start is by opening `apps/KitchenSink/index.html` in your browser. The KitchenSink application is a good starting point to the Rappid framework. You can even use it as a foundation for your own applications and customize it to your needs.


## Directory Structure

* `apps` - Various demo applications built with Rappid.

  `KitchenSink` - A demo application (the one that you can see at http://jointjs.com/demos/rappid).
  `BPMNEditor` - A BPMN editor example application (the one that you can see at http://jointjs.com/demos/bpmn).
  `Tree` - A demo showing powerful tree layout plugin (http://jointjs.com/demos/tree).
  `OrgChart` - An organization chart demo (http://jointjs.com/demos/orgchart).
  `QAD` - A dialog generator (http://jointjs.com/demos/qad).

* `3rdParty` - Demo applications showing integration with other frameworks.

   `AngularJS`
   `NodeWebkit`


## Support

Please use our [JointJS](https://github.com/clientIO/joint/issues) repository on GitHub to file bugs and feature requests. We cannot guarantee a response time but we'll do our best to fix bugs as soon as we can. Commercial support is available as well (see the [JointJS support page](http://jointjs.com/support)). If you have any questions, drop us an email at [support@client.io](mailto:support@client.io).

## License

Rappid UI framework is licensed under the [Rappid License](http://jointjs.com/license/rappid).

Copyright (c) 2016 client IO
